/*
 * (c) SPDsoft 1993/2005 + GIGA
 * Display a JFIF file using OpenGL
 * version 1.2.1
 * Uses IJG code v6b or ImageMagick 5.x
 *
 */

#ifdef _WINDOWS
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#ifndef _WINDOWS
#include <unistd.h>
#include <limits.h>
#else
extern int getopt( int argc, char **argv, char *opts);
#endif
#include <math.h>

#include <sys/types.h>
#include <time.h>


#if defined(__MACH__) && defined(__APPLE__) /* OS X */
#include <OpenGL/CGLContext.h>
#include <OpenGL/CGLCurrent.h>
#include <OpenGL/CGLTypes.h>
#include <OpenGL/OpenGL.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#if defined(__MACOS__) /* MacOS 9 */
#include <glu.h>
#else
#include <GL/glu.h>
#endif
#include <GL/glut.h>
#endif

#ifdef __sgi
#ifndef NEW_SGI_STEREO_MODE
#define OLD_SGI_STEREO
#include "fullscreen_stereo.h"
#endif
#endif


#ifdef USE_MAGICK
#include <magick/api.h>
#else
#include <jpeglib.h>
#include <setjmp.h>
#endif

#ifdef __sgi
#ifndef NEW_SGI_STEREO_MODE
#define OLD_SGI_STEREO
#include "fullscreen_stereo.h"
#endif
#endif


#ifndef PATH_SEP
# define PATH_SEP	'/'
#endif


#define ALPHA_OPAC	0x00
#define YSTEREO 491
#define YOFFSET_LEFT (1024 - (YSTEREO+1))
#define SCREEN_W	G_prefs.screen_w
#define SCREEN_H	G_prefs.screen_h

#define Boolean	int 
#define Output	if (G_prefs.Verbose) printf

#ifndef MIN
#define MIN(a,b) ((a)>(b)?(b):(a))
#endif

typedef struct { 
			char 	*AppName;
			Boolean FullScreen;	
			Boolean FillScreen;	
			Boolean FillScreen_opt;	
			Boolean StereoDisplay;	
			Boolean Stereo;	
			Boolean Crossed;	
			Boolean Anaglyph;	
			Boolean Growable;	
			Boolean KeepAspectRatio;	
			Boolean Verbose;	
			Boolean OSD;	
			int		SlideShow;	
			long	screen_w;
			long	screen_h;
			long	window_size[2];
			char	*filename;
		}  pref;

#define gw_x	(G_prefs.window_size[0])
#define gw_y	(G_prefs.window_size[1])

/*
 * Prototypes
 */
void	init_graphics(void);
void	IdleGL(void);
void	ReSizeGLScene(int Width, int Height);
void	keyPressed(unsigned char key, int x, int y);
void	DrawGLScene(void);
void    usage(char *name);
void    fatalError(char *str);
void	get_options(int argc,char *argv[]);
void	draw_string (void * font, char *s);

#ifndef USE_MAGICK
/*
 * JPEG Prototypes
 */

static void		my_error_exit (j_common_ptr cinfo);
#endif
int				read_file (char * filename, unsigned char **fb, unsigned char **fb2);


extern char     *optarg;
extern int      optind,opterr;

unsigned		image_H;
unsigned		image_W;
long			monitor;
long			mouse;
long			offset=0;
GLfloat         scale;
int				f;
#define framebuffer_r framebuffer
unsigned char	*framebuffer=NULL,
				*framebuffer_l=NULL,
				*pix, *pix2;

int				next=1;
int				arg_n;
char			**argv_g;
time_t			time_next; 


pref			G_prefs;

#ifndef USE_MAGICK
static char __ident[] = "@(#)(c) SPDsoft, (Uses IJG code v6b), 1.2.1 Feb 2006";
#else
static char __ident[] = "@(#)(c) SPDsoft, (Uses ImageMagick), 1.2.1 Feb 2006";
#endif
#define VERS_STR    ((char*)&__ident[4])

/*****************************************************/

void    usage(char *name)
{
    fprintf(stderr,
    "usage: %s [-b|-F|-g|-G][-s sec][-fvhxa][-3|-4 left right|files...]"
	"\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
	name,
	"-b: Full screen",
	"-3: Stereo",
	"-x: Stereo crossed (r|l)",
	"-a: Stereo anaglyph to grayscale",
	"-F: Fill full screen",
	"-g: Growable, Keep aspect ratio",
	"-G: Growable",
	"-s: Slide Show (seconds)",
	"-v: Version, debug",
	"-h: This text. Note: Press <esc> to go to next image"
	);
    exit(-1);
}

void    fatalError(char *str)
{
    fprintf(stderr, "%s: Fatal Error: %s. bye...\n",G_prefs.AppName,str);
    fprintf(stderr, "%s: %s\n",G_prefs.AppName,strerror(errno));
#ifdef OLD_SGI_STEREO
	if (G_prefs.StereoDisplay)
		stop_fullscreen_stereo();
#endif
    exit(-2);
}

#ifndef USE_MAGICK
struct my_error_mgr
{
	struct jpeg_error_mgr pub;	/* "public" fields */
	jmp_buf setjmp_buffer;		/* for return to caller */
};

typedef struct my_error_mgr * my_error_ptr;

static void my_error_exit (j_common_ptr cinfo)
{
	my_error_ptr myerr = (my_error_ptr) cinfo->err;

	(*cinfo->err->output_message) (cinfo);
	longjmp(myerr->setjmp_buffer, 1);
}
#endif

#ifdef USE_MAGICK
int read_file (char * filename, unsigned char **fb, unsigned char **fb2)
{
	Image *image;
	ImageInfo *image_info;
	ExceptionInfo exception;
	PixelPacket	q;
	int i,j;

	image_info=CloneImageInfo((ImageInfo *) NULL);
	if (filename != NULL)
	{
		(void) strcpy(image_info->filename,filename);
	}
	else
	{
		(void) strcpy(image_info->filename,"-");
	}
	if (G_prefs.filename!=NULL) free(G_prefs.filename);
	G_prefs.filename=strdup(image_info->filename);

	image=ReadImage(image_info,&exception);


	image_H=image->rows;
	image_W=image->columns;

	if (( NULL != fb2 )&&(!G_prefs.Anaglyph))
		image_W /=2 ;


/*
 * Framebuffer
 */
	Output("%03d %s\t%u\t%u\t",f,filename,image_W,image_H );
	if (G_prefs.Verbose) fflush(stdout);

	if((( image_W > SCREEN_W ) || ( image_H > SCREEN_H))&&(G_prefs.FullScreen))
			G_prefs.FillScreen=1;
	else
			G_prefs.FillScreen=G_prefs.FillScreen_opt;
			
	*fb =
		(unsigned char *)calloc( (size_t)image_H * (size_t)image_W , (size_t)4);
	
	if (*fb==NULL) fatalError("Out of memory");
	pix = *fb + (size_t)4*image_W*(image_H-1);


	if ( NULL != fb2 )
	{
	*fb2 =
		(unsigned char *)calloc( (size_t)image_H * (size_t)image_W , (size_t)4);
	
	if (*fb2==NULL) fatalError("Out of memory");
	pix2 = *fb2 + (size_t)4*image_W*(image_H-1);
	}

/*
 * Draw to framebuffer
 */


	for(i=0; i<image_H; i++)
	{
		for(j=0; j<image_W; j++)
		{
			q=GetOnePixel(image, j, i); 

			if (G_prefs.Anaglyph)
			{
				*pix++ = q.blue;
				*pix++ = q.blue;
				*pix++ = q.blue;
				*pix++ = q.opacity;
				*pix2++ = q.red;
				*pix2++ = q.red;
				*pix2++ = q.red;
				*pix2++ = q.opacity;
			}
			else
			{
				*pix++ = q.red;
				*pix++ = q.green;
				*pix++ = q.blue;
				*pix++ = q.opacity;
			}
		}
		if (( NULL != fb2 )&&(!G_prefs.Anaglyph))
		{
			for (j=image_W; j<2*image_W; j++)
			{
				q=GetOnePixel(image, j, i); 
				*pix2++ = q.red;
				*pix2++ = q.green;
				*pix2++ = q.blue;
				*pix2++ = q.opacity;
			}
		}
		pix -= 8* image_W;
		pix2 -= 8* image_W;
	}


	DestroyImage(image);


	return 0;
}
#else
int read_file (char * filename, unsigned char **fb, unsigned char **fb2)
{
	struct jpeg_decompress_struct cinfo;
	struct my_error_mgr jerr;

	FILE		*infile;			/* source file */
	JSAMPARRAY	buffer;				/* Output row buffer */
	int			row_stride;         /* physical row width in output buffer */
	register JSAMPROW inptr;

	int j,w;

	if (G_prefs.filename!=NULL) free(G_prefs.filename);
	
	if (filename != NULL)
	{
		if ((infile = fopen(filename, "rb")) == NULL)
		{
			fatalError(filename);
		}
		G_prefs.filename=strdup(filename);
	}
	else
	{
		infile = stdin;
		G_prefs.filename=strdup("-");
	}

	cinfo.err = jpeg_std_error(&jerr.pub);
	jerr.pub.error_exit = my_error_exit;
	if (setjmp(jerr.setjmp_buffer))
	{
	/* If we get here, the JPEG code has signaled an error.
	 * We need to clean up the JPEG object, close the input file, and return.
	 */
		jpeg_destroy_decompress(&cinfo);
		fclose(infile);
		return NULL;
	}


	jpeg_create_decompress(&cinfo);
	jpeg_stdio_src(&cinfo, infile);
	(void) jpeg_read_header(&cinfo, TRUE);

	jpeg_start_decompress(&cinfo);

	image_H = cinfo.output_height;
	image_W = cinfo.output_width;

	row_stride = cinfo.output_width * cinfo.output_components;
	buffer = (*cinfo.mem->alloc_sarray)
		((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);


	if (( NULL != fb2 )&&(!G_prefs.Anaglyph))
		image_W /=2 ;
/*
 * Framebuffer
 */
	Output("%03d %s\t%u\t%u\t",f,filename,image_W,image_H );
	if((( image_W > SCREEN_W ) || ( image_H > SCREEN_H))&&(G_prefs.FullScreen))
			G_prefs.FillScreen=1;
	else
			G_prefs.FillScreen=G_prefs.FillScreen_opt;
			
	*fb =
		(unsigned char *)calloc( (size_t)image_H * (size_t)image_W , (size_t)4);
	
	if ((*fb==NULL)||(buffer==NULL)) fatalError("Out of memory");
	pix = *fb + (size_t)4*image_W*(image_H-1);
	w=cinfo.output_width;

	if ( NULL != fb2 )
	{
	*fb2 =
		(unsigned char *)calloc( (size_t)image_H * (size_t)image_W , (size_t)4);
	
	if (*fb2==NULL) fatalError("Out of memory");
	pix2 = *fb2 + (size_t)4*image_W*(image_H-1);
	if (!G_prefs.Anaglyph)
		w=cinfo.output_width/2;
	}

/*
 * Draw to framebuffer
 */
	if ( cinfo.output_components != 1 )
	{
		Output("RGB image\n");
		while (cinfo.output_scanline < cinfo.output_height)
		{
			(void) jpeg_read_scanlines(&cinfo, buffer, 1);
			for (j=0, inptr=*buffer; j<w; j++)
			{
				if (G_prefs.Anaglyph)
				{
					/*
					 * Red Channel: Left Eye (Red lens)
					 * Green+Blue Channel: Rigth Eye (Cyan lens)
					 * lrectwrite(3G) -> 0xAABBGGRR
					 * glDrawPixels -> 0xRRGGBBAA
					 */
					*pix++ = (char)inptr[1];
					*pix++ = (char)inptr[1];
					*pix++ = (char)inptr[1];
					*pix++ = ALPHA_OPAC;
					*pix2++ = (char)inptr[0];
					*pix2++ = (char)inptr[0];
					*pix2++ = (char)inptr[0];
					*pix2++ = ALPHA_OPAC;
				}
				else
				{
					*pix++ = (char)inptr[0];
					*pix++ = (char)inptr[1];
					*pix++ = (char)inptr[2];
					*pix++ = ALPHA_OPAC;
				}
				inptr += 3;
			}
			pix -= 8* image_W;
			if (( NULL != fb2 )&&(!G_prefs.Anaglyph))
			{
				for (j=0; j<w ; j++)
				{
					*pix2++ = (char)inptr[0];
					*pix2++ = (char)inptr[1];
					*pix2++ = (char)inptr[2];
					*pix2++ = ALPHA_OPAC;
					inptr += 3;
				}
			}
			pix2 -= 8* image_W;
		}
	}
	else
	{
		Output("Grayscale image\n");
		while (cinfo.output_scanline < cinfo.output_height)
		{
			(void) jpeg_read_scanlines(&cinfo, buffer, 1);
            for (j=0, inptr=*buffer; j<w; j++)
            {
				*pix++ = (char)inptr[0];
				*pix++ = (char)inptr[0];
				*pix++ = (char)inptr[0];
				*pix++ = ALPHA_OPAC;
				inptr += 1;
            }
			pix -= 8* image_W;
			if (( NULL != fb2 )&&(!G_prefs.Anaglyph))
			{
				for (j=0; j<w ; j++)
				{
					*pix2++ = (char)inptr[0];
					*pix2++ = (char)inptr[0];
					*pix2++ = (char)inptr[0];
					*pix2++ = ALPHA_OPAC;
					inptr += 1;
				}
				pix2 -= 8* image_W;
			}
        }

	}

/*
 * Finish
 */
	(void) jpeg_finish_decompress(&cinfo);
	jpeg_destroy_decompress(&cinfo);
	fclose(infile);

	return 0;
}
#endif


/*****************************************************/

void	get_options(int argc,char *argv[])
{
	int opcion;
	int theError=0;

	if ((G_prefs.AppName = strrchr(argv[0], PATH_SEP))  != NULL)
			G_prefs.AppName = G_prefs.AppName+1;
	else
			G_prefs.AppName = argv[0];

	G_prefs.FullScreen		= 0;
	G_prefs.FillScreen		= 0;
	G_prefs.FillScreen_opt	= 0;
	G_prefs.SlideShow		= -1;
	G_prefs.Growable		= 0;
	G_prefs.Stereo			= 0;
	G_prefs.StereoDisplay	= 0;
	G_prefs.Crossed			= 0;
	G_prefs.Anaglyph		= 0;
	G_prefs.KeepAspectRatio	= 1;
	G_prefs.Verbose			= 0;
	G_prefs.OSD				= 0;
	G_prefs.filename		= NULL;

	while ( (opcion=getopt(argc,argv,"s:3bFgGvxXah")) != EOF )
	{
		switch(opcion)
		{
				case '3':
						G_prefs.Stereo = 1;
						G_prefs.StereoDisplay = 1;
						G_prefs.FullScreen = 1;
						break;
				case 'a':
						G_prefs.Anaglyph = 1;
						G_prefs.StereoDisplay = 1;
						G_prefs.FullScreen = 1;
						break;
				case 'x':
						G_prefs.Crossed = 1;
						G_prefs.StereoDisplay = 1;
						G_prefs.FullScreen = 1;
						break;
				case 'X':
						G_prefs.Crossed = 1;
						G_prefs.FullScreen = 1;
						break;
				case 'b':
						G_prefs.FullScreen = 1;
						break;
				case 'F':
						G_prefs.FullScreen = 1;
						G_prefs.FillScreen = 1;
						G_prefs.FillScreen_opt = 1;
						break;
				case 'g':
						G_prefs.Growable = 1;
						break;
				case 's':
						G_prefs.SlideShow = atoi(optarg);
						break;
				case 'G':
						G_prefs.Growable = 1;
						G_prefs.KeepAspectRatio = 0;
						break;
				case 'v':
						printf("%s:%s\n",G_prefs.AppName,VERS_STR);
						G_prefs.Verbose=1;
						break;
				default:
						usage(G_prefs.AppName);
		}
		if ( theError!=0)  usage(G_prefs.AppName);
	}
}

void draw_string (void * font, char *s)
{
	char *p;
	glColor3f(0.0, 0.0, 0.0);
	glRasterPos2f (-0.96,0.96);
	for (p=s;*p;)
		glutBitmapCharacter (font, *p++);
	glColor3f(1.0, 1.0, 1.0);
	glRasterPos2f (-0.959,0.959);
	for (p=s;*p;)
		glutBitmapCharacter (font, *p++);
}


main(int argc,char *argv[])
{
#if defined(__MACH__) && defined(__APPLE__) /* OS X */
	char p[PATH_MAX];
#endif
	int gwid;

	argv_g=argv;


#ifdef USE_MAGICK
	InitializeMagick(*argv);
#endif
#if defined(__MACH__) && defined(__APPLE__) /* OS X */
	getwd(p);
#endif
	glutInit(&argc, argv);
#if defined(__MACH__) && defined(__APPLE__) /* OS X */
	/* glutInit seems to change cwd - tested on MacOS X */
	chdir(p);
#endif

	get_options(argc,argv);

	if (G_prefs.StereoDisplay)
	{
#ifdef OLD_SGI_STEREO
			glutInitDisplayMode(GLUT_RGBA);
#else   
			glutInitDisplayMode(GLUT_RGBA|GLUT_STEREO);
#endif  
	}   
	else
	{
		glutInitDisplayMode(GLUT_RGBA);
	}

	init_graphics();

	if(G_prefs.FullScreen||G_prefs.StereoDisplay)
	{
			gw_x=SCREEN_W;
			gw_y=SCREEN_H;
			glutInitWindowSize(gw_x,gw_y);
			glutInitWindowPosition( 0, 0);
			gwid = glutCreateWindow("gdj");
			glutFullScreen();
	}
	else
	{
			gw_x=100;
			gw_y=100;
			glutInitWindowSize(gw_x,gw_y);
			glutInitWindowPosition( 20, 20);
			gwid = glutCreateWindow("gdj");
	}

#ifdef OLD_SGI_STEREO
	if ( G_prefs.StereoDisplay )
	{
		start_fullscreen_stereo();
	}
#endif


	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glViewport( 0, 0, gw_x, gw_y );
	if ( G_prefs.StereoDisplay )
	{
		/* left eye */
#ifdef OLD_SGI_STEREO
		stereo_left_buffer();
#else
		glDrawBuffer(GL_BACK_LEFT);
#endif
		glClear(GL_COLOR_BUFFER_BIT);
#ifdef OLD_SGI_STEREO
		stereo_right_buffer();
#else
		glDrawBuffer(GL_BACK_RIGHT);
#endif
		glClear(GL_COLOR_BUFFER_BIT);
	}
	else
		glClear(GL_COLOR_BUFFER_BIT);

	glutDisplayFunc(&DrawGLScene);
	glutIdleFunc(&IdleGL);

	glutReshapeFunc(&ReSizeGLScene);
	glutKeyboardFunc(&keyPressed);


	if (optind==argc)
	{
		argc ++;
	}
	arg_n=optind;

	time_next = time(NULL) + G_prefs.SlideShow;
	glutMainLoop();

	if(G_prefs.FullScreen) glutDestroyWindow(gwid);

	if( G_prefs.StereoDisplay )
	{
#ifdef OLD_SGI_STEREO
		stop_fullscreen_stereo();
#endif
	}
#ifdef USE_MAGICK
	DestroyMagick();
#endif
	return(0);
}

void IdleGL(void)
{
	if (next)
	{
		if (framebuffer_l)
		{
			free(framebuffer_l);
			framebuffer_l=NULL;
		}
		if (framebuffer_r)
		{
			free(framebuffer_r);
			framebuffer_r=NULL;
		}

		if ( NULL == argv_g[arg_n] )
		{
#ifdef OLD_SGI_STEREO
			if (G_prefs.StereoDisplay)
				stop_fullscreen_stereo();
#endif
			exit(1);
		}
		if (G_prefs.Stereo)
		{
			read_file(argv_g[arg_n++],&framebuffer_l,NULL);
			if ( NULL == argv_g[arg_n] )
			{
#ifdef OLD_SGI_STEREO
				if (G_prefs.StereoDisplay)
					stop_fullscreen_stereo();
#endif
				exit(1);
			}
			read_file(argv_g[arg_n++],&framebuffer_r,NULL);
		}
		else if (G_prefs.Crossed||G_prefs.Anaglyph)
		{
			read_file(argv_g[arg_n++],&framebuffer_r,&framebuffer_l);
		}
		else
			read_file(argv_g[arg_n++],&framebuffer_r,NULL);

		if(!G_prefs.FullScreen)
		{
			unsigned w_W, w_H;
			w_W = image_W;
			w_H = image_H;

			if (w_W > SCREEN_W - 20 )
			{
				w_H= w_H * ((float)(SCREEN_W - 20)/(float)w_W);
				w_W=SCREEN_W - 20;
			}
			if (w_H > SCREEN_H - 20 )
			{
				w_W= w_W * ((float)(SCREEN_H - 20)/(float)w_H);
				w_H=SCREEN_H - 20;
			}
			
			glutReshapeWindow(w_W, w_H);
			scale= MIN( (float)gw_x/(float)image_W,
						(float)gw_y/(float)image_H);
		}

		glClear(GL_COLOR_BUFFER_BIT);
		glutPostRedisplay();
		next=0;
	}
	if ( 0 < G_prefs.SlideShow )
	{

/*static float time*/
/*      time = glutGet(GLUT_ELAPSED_TIME) / 500.0;*/
/*        jump = 3.0 * fabs(sin(time));*/
/*          glutPostRedisplay();*/

		if ( time(NULL) > time_next )
		{
			time_next += G_prefs.SlideShow;
			next=1;
		}
	}
}

void	ReSizeGLScene(int Width, int Height)
{
	if (Height==0)  /* Prevent A Divide By Zero If The Window Is Too Small*/
		Height=1;

	glViewport(0, 0, Width, Height);

	G_prefs.window_size[0]=Width;
	G_prefs.window_size[1]=Height;

}

void keyPressed(unsigned char key, int x, int y)
{
#define ESCAPE 27

	/* avoid thrashing this call */
#ifndef _WINDOWS
	sleep(0.1);
#endif
		    
	switch( key )
	{
		case ESCAPE:
			next=1;
			break;

		case 'o':
			G_prefs.OSD=!G_prefs.OSD;
			glutPostRedisplay();
			break;

		case 'f':

			G_prefs.FullScreen=!G_prefs.FullScreen;
			glutPostRedisplay();
			break;

		default:
			if(G_prefs.Verbose)
			{
				printf("Event: %d\n", key);
				fflush(stdout);
			}
			break;
	}
}


void init_graphics(void)
{
	G_prefs.screen_w = glutGet(GLUT_SCREEN_WIDTH);
	G_prefs.screen_h = glutGet(GLUT_SCREEN_HEIGHT);

	Output("# SCREEN: %dx%d\n", G_prefs.screen_w,G_prefs.screen_h);

	if (( G_prefs.screen_w <= 0 ) || ( G_prefs.screen_h <= 0 ))
		fatalError("glutGet failed");

}

void DrawGLScene(void)
{
	char tmpStr[128];
	static Boolean full=0;

	if (image_W==0 || image_H == 0)
		return;

	/* resize, reshape gw_x, gw_y, glPixelZoom */
	if(G_prefs.FullScreen) 
	{
		float x,y;
		if (!full)
		{
			glutReshapeWindow(gw_x, gw_y);
			glutPositionWindow( 0, 0);
			glutFullScreen();

			full=1;
		}
		scale= MIN( (float)gw_x/(float)image_W,
					(float)gw_y/(float)image_H);

		if((!G_prefs.FillScreen) && ((float)scale >  1.0))
			scale = 1.0;


		x=(float)image_W*scale/(float)G_prefs.screen_w;
		y=(float)image_H*scale/(float)G_prefs.screen_h;

		/*
		 * It seems there is some bug in glut
		 * I don't know why, but this work (otherwise
		 * you get a black screen)
		 */
#define EPSILON 0.000001f

		if ( 1.0-x <= EPSILON ) x-=0.000001f;
		if ( 1.0-y <= EPSILON ) y-=0.000001f;
		glRasterPos2f(-x,-y);

/*		{*/
/*			GLfloat f[4];*/
/*			glGetFloatv(GL_CURRENT_RASTER_POSITION, f);*/
/*			printf("%g,%g should be %g,%g\n",f[0],f[1],x,y);*/
/*		}*/

		if(G_prefs.StereoDisplay)
		{
			glPixelZoom(scale,scale/2);
		}
		else
		{
			glPixelZoom(scale,scale);
		}

	}
	else
	{
		if (full)
		{
			unsigned w_W, w_H;
			full=0;
			w_W = image_W;
			w_H = image_H;

			if (w_W > SCREEN_W - 20 )
			{
				w_H= w_H * ((float)(SCREEN_W - 20)/(float)w_W);
				w_W=SCREEN_W - 20;
			}
			if (w_H > SCREEN_H - 20 )
			{
				w_W= w_W * ((float)(SCREEN_H - 20)/(float)w_H);
				w_H=SCREEN_H - 20;
			}
			
			glutReshapeWindow(w_W, w_H);
			ReSizeGLScene(w_W, w_H);
			glutPositionWindow( 20, 20);
			scale= MIN( (float)gw_x/(float)image_W,
						(float)gw_y/(float)image_H);
		}
		glRasterPos2f(-1,-1);
		glPixelZoom(
			(GLfloat)gw_x/(GLfloat)image_W,
			(GLfloat)gw_y/(GLfloat)image_H );
	}

	if (G_prefs.StereoDisplay)
	{
		/* left eye */
#ifdef OLD_SGI_STEREO
		stereo_left_buffer();
#else
		glDrawBuffer(GL_BACK_LEFT);
#endif
		glClear(GL_COLOR_BUFFER_BIT);
		glDrawPixels(image_W,image_H,GL_RGBA,GL_UNSIGNED_BYTE,framebuffer_l);
		/* right eye */
#ifdef OLD_SGI_STEREO
		stereo_right_buffer();
#else
		glDrawBuffer(GL_BACK_RIGHT);
#endif
		glClear(GL_COLOR_BUFFER_BIT);
		glDrawPixels(image_W,image_H,GL_RGBA,GL_UNSIGNED_BYTE,framebuffer_r);
	}
	else
	{
		glClear(GL_COLOR_BUFFER_BIT);
		glDrawPixels(image_W,image_H,GL_RGBA,GL_UNSIGNED_BYTE,framebuffer);
	}
	if ( G_prefs.OSD )
	{
		sprintf(tmpStr, "%.32s: %ux%u (%2.f%%)",
			G_prefs.filename,image_W,image_H,100*scale );
		draw_string(GLUT_BITMAP_HELVETICA_12,tmpStr);
	}

	glFlush();
}



